VERSION 5.00
Begin VB.UserControl LiteButton 
   Alignable       =   -1  'True
   AutoRedraw      =   -1  'True
   ClientHeight    =   390
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   390
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   MaskColor       =   &H00FF00FF&
   ScaleHeight     =   26
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   26
   ToolboxBitmap   =   "LiteButton.ctx":0000
   Begin VB.PictureBox pBtnPic 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   255
      Left            =   60
      ScaleHeight     =   17
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   16
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   60
      Visible         =   0   'False
      Width           =   240
      Begin VB.Timer Timer1 
         Enabled         =   0   'False
         Interval        =   150
         Left            =   -60
         Top             =   -60
      End
   End
End
Attribute VB_Name = "LiteButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function SetPixel Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long

Private Declare Function SetCapture Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetCapture Lib "user32" () As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long
Private Declare Function SetTextColor Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long

Private Declare Function OleTranslateColor Lib "oleaut32.dll" (ByVal lOleColor As Long, ByVal lHPalette As Long, lColorRef As Long) As Long

Private Declare Function FillRect Lib "user32" (ByVal hDC As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function FrameRect Lib "user32" (ByVal hDC As Long, lpRect As RECT, ByVal hBrush As Long) As Long

Private Declare Function DrawEdge Lib "user32" (ByVal hDC As Long, qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long) As Long
Private Const BF_BOTTOM = &H8
Private Const BF_LEFT = &H1
Private Const BF_RIGHT = &H4
Private Const BF_TOP = &H2
Private Const BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)

Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hDC As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Private Const DT_VCENTER = &H4&
Private Const DT_SINGLELINE = &H20&
Private Const DT_WORD_ELLIPSIS = &H40000
Private Const DT_LEFT = &H0
Private Const DT_RIGHT = &H2
Private Const DT_CENTER = &H1

'Events
Event Click()
Event MouseEnter()
Event MouseExit()
Event ClickRepeat()

''Public Enum eStyle
''    bsNormal
''    bsSkin
''End Enum
Public Enum eAlignment
    alLeft
    alRight
    alCenter
End Enum
Public Enum eEdgeUp
    bsSoftUp = &H4
    bsDefaultUp = &H5
    bsNoneUp = 0&
End Enum
Public Enum eEdgeDn
    bsSoftDn = &H2
    bsDefaultDn = &HA
End Enum

Dim m_Pushed As eEdgeDn
Dim m_UnPushed As eEdgeUp
Dim m_Hover As eEdgeUp
Dim m_Font As StdFont
Dim m_Caption As String
Dim m_Enabled As Boolean
Dim m_Align As eAlignment
Dim m_HClr As OLE_COLOR
Dim m_FClr As OLE_COLOR
Dim m_DClr As OLE_COLOR
Dim m_PBClr As OLE_COLOR
Dim m_BackColor As OLE_COLOR
Dim m_FocusColor As OLE_COLOR
Dim m_DrawFocusRect As Boolean

Dim iStatus As Integer
Dim fIns As Boolean
Dim fFocus As Boolean
Dim buttonIsPressed As Boolean
Dim timerDelay As Long

Private Function TranslateColor(ByVal clr As OLE_COLOR, Optional hPal As Long = 0) As Long
    If OleTranslateColor(clr, hPal, TranslateColor) Then
        TranslateColor = -1
    End If
End Function

Private Sub Render(Optional ByVal bPressed As Boolean = False, Optional ByVal bHover As Boolean = False)
    Dim lFlags As Long
    Dim rct As RECT   ' Button Rect
    Dim rT As RECT    ' Text Rect
    Dim fRct As RECT  ' Focus Rect
    Dim hBr As Long   ' Background/focus brush
    
    hBr = CreateSolidBrush(TranslateColor(m_BackColor))
    rct.Top = 0
    rct.Left = 0
    rct.Right = ScaleWidth
    rct.Bottom = ScaleHeight
    FillRect hDC, rct, hBr
    DeleteObject hBr

    'Draw Text
    LSet rT = rct
    If m_Align = alLeft Then
        lFlags = DT_LEFT
    ElseIf m_Align = alRight Then
        lFlags = DT_RIGHT
    ElseIf m_Align = alCenter Then
        lFlags = DT_CENTER
    End If

    If m_Enabled = False Then
        SetTextColor hDC, TranslateColor(vb3DHighlight)
        rT.Top = 3.5
        rT.Bottom = rct.Bottom - 2
        If pBtnPic.Picture <> Empty Then
            rT.Left = pBtnPic.ScaleWidth + 8
        Else
            rT.Left = 5
        End If
        rT.Right = rct.Right - 3
        DrawText hDC, m_Caption, Len(m_Caption), rT, lFlags Or DT_SINGLELINE Or DT_WORD_ELLIPSIS Or DT_VCENTER
 
        SetTextColor hDC, TranslateColor(vb3DShadow)
        rT.Top = 2
        rT.Bottom = rct.Bottom - 2
        If pBtnPic.Picture <> Empty Then
            rT.Left = pBtnPic.ScaleWidth + 7
        Else
            rT.Left = 4
        End If
        rT.Right = rct.Right - 4
        DrawText hDC, m_Caption, Len(m_Caption), rT, lFlags Or DT_SINGLELINE Or DT_WORD_ELLIPSIS Or DT_VCENTER
    Else
        rT.Top = 1 - bPressed
        rT.Bottom = rct.Bottom - 1 - bPressed
        If pBtnPic.Picture <> Empty Then
            rT.Left = pBtnPic.ScaleWidth + 7 - bPressed
        Else
            rT.Left = 4
        End If
        rT.Right = rct.Right - 4 - bPressed
        DrawText hDC, m_Caption, Len(m_Caption), rT, lFlags Or DT_SINGLELINE Or DT_WORD_ELLIPSIS Or DT_VCENTER
    End If

    'Draw Image
    If pBtnPic.Picture <> Empty Then
        If m_Enabled Then
            If bPressed Then
                If pBtnPic.Picture <> Empty Then
                    BitBlt hDC, 4 - bPressed, (ScaleHeight - pBtnPic.ScaleHeight) / 2 + 0.5 - bPressed, pBtnPic.ScaleWidth, pBtnPic.ScaleHeight, pBtnPic.hDC, 0, 0, vbSrcCopy
                End If
            Else
                If pBtnPic.Picture <> Empty Then
                    BitBlt hDC, 4, (ScaleHeight - pBtnPic.ScaleHeight) / 2 + 0.5, pBtnPic.ScaleWidth, pBtnPic.ScaleHeight, pBtnPic.hDC, 0, 0, vbSrcCopy
                End If
            End If
        Else
            If pBtnPic.Picture <> Empty Then
                BitBlt hDC, 4, (ScaleHeight - pBtnPic.ScaleHeight) / 2 + 0.5, pBtnPic.ScaleWidth, pBtnPic.ScaleHeight, pBtnPic.hDC, 0, 0, vbSrcCopy
            End If
        End If
    End If

    'Draw Edge
    If bHover And bPressed = False Then
        DrawEdge hDC, rct, m_Hover, BF_RECT
    Else
        DrawEdge hDC, rct, IIf(bPressed, m_Pushed, m_UnPushed), BF_RECT
    End If
    
    'Draw Focus rect
    LSet fRct = rct
    If fFocus And bPressed = False And m_DrawFocusRect Then
        hBr = CreateSolidBrush(TranslateColor(m_FocusColor))
        fRct.Top = 1
        fRct.Left = 1
        fRct.Right = ScaleWidth - 1
        fRct.Bottom = ScaleHeight - 1
        FrameRect hDC, fRct, hBr
        fRct.Top = 2
        fRct.Left = 2
        fRct.Right = ScaleWidth - 2
        fRct.Bottom = ScaleHeight - 2
        FrameRect hDC, fRct, hBr
        DeleteObject hBr
    End If
    
    Refresh
End Sub

Private Sub Timer1_Timer()
    timerDelay = timerDelay + 1
    If timerDelay > 2 Then RaiseEvent ClickRepeat
End Sub

Private Sub UserControl_ExitFocus()
'    Debug.Print "ExitFocus"
    SetTextColor hDC, TranslateColor(m_FClr)
    fFocus = False
    buttonIsPressed = False
    Render
    fIns = False
    iStatus = 0
End Sub

Private Sub UserControl_GotFocus()
'    Debug.Print "GotFocus"
    fFocus = True
    Render buttonIsPressed
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeySpace Then
        SetTextColor hDC, TranslateColor(m_DClr)
        buttonIsPressed = True
        Render True
        iStatus = 1
        Timer1.Enabled = True
    End If
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeySpace Then
        buttonIsPressed = False
        If iStatus = 1 Then
            fIns = False
            SetTextColor hDC, TranslateColor(m_FClr)
            Render
            RaiseEvent Click
            iStatus = 0
            Timer1.Enabled = False: timerDelay = 0
        End If 'iStatus
    End If 'Mouse Button
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
'    Debug.Print "MouseDown"
    If Button = 1 Then
        SetTextColor hDC, TranslateColor(m_DClr)
        buttonIsPressed = True
        Render True
        iStatus = 1
        Timer1.Enabled = True
    End If
    DoEvents
    UserControl.Refresh
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim ret As Long
    Dim rct As RECT

'    Debug.Print "MouseMove"
    If Button = vbLeftButton Then
        If iStatus = 1 Then
            If GetCapture() <> hwnd Then
                ret = SetCapture(hwnd)
                SetTextColor hDC, TranslateColor(m_DClr)
                Render True
            End If
            If X > 0 And X < ScaleWidth And Y > 0 And Y < ScaleHeight Then
                SetTextColor hDC, TranslateColor(m_DClr)
                Render True
            Else
                SetTextColor hDC, TranslateColor(m_FClr)
                Render , True
            End If
        Else
        End If
    Else
        If X < 0 Or X > ScaleWidth Or Y < 0 Or Y > ScaleHeight Then
            fIns = False
            ret = ReleaseCapture()
            RaiseEvent MouseExit
            SetTextColor hDC, TranslateColor(m_FClr)
            Render
        Else
            If fIns = False Then
                fIns = True
                ret = SetCapture(UserControl.hwnd)
                RaiseEvent MouseEnter
                SetTextColor hDC, TranslateColor(m_HClr)
                Render , True
            End If
        End If
    End If
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
'    Debug.Print "MouseUp"
    If Button = 1 Then
        buttonIsPressed = False
        Timer1.Enabled = False: timerDelay = 0
        If iStatus = 1 Then
            If X > 0 And X < ScaleWidth And Y > 0 And Y < ScaleHeight Then
                fIns = False
                SetTextColor hDC, TranslateColor(m_FClr)
                Render
                RaiseEvent Click
                iStatus = 0
            Else
                SetTextColor hDC, TranslateColor(m_FClr)
                Render
                iStatus = 0
                fIns = False
            End If 'XY Pos
        End If 'iStatus
    End If 'Mouse Button
    DoEvents
    UserControl.Refresh
End Sub

Private Sub UserControl_Resize()
'    Debug.Print "Resize"
    RefreshIt
End Sub

Public Property Get DrawFocusRect() As Boolean
    DrawFocusRect = m_DrawFocusRect
End Property

Public Property Let DrawFocusRect(ByVal NewBool As Boolean)
    m_DrawFocusRect = NewBool
    PropertyChanged "DrawFocusRect"
    RefreshIt
End Property

Public Property Get Caption() As String
Attribute Caption.VB_UserMemId = -517
    Caption = m_Caption
End Property

Public Property Let Caption(ByVal NewStr As String)
    m_Caption = NewStr
    PropertyChanged "Caption"
    RefreshIt
End Property

Public Property Get Enabled() As Boolean
    Enabled = m_Enabled
End Property

Public Property Let Enabled(ByVal NewBool As Boolean)
    m_Enabled = NewBool
    PropertyChanged "Enabled"
    UserControl.Enabled = m_Enabled
    RefreshIt
End Property

Public Property Get Alignment() As eAlignment
    Alignment = m_Align
End Property

Public Property Let Alignment(ByVal NewAl As eAlignment)
    m_Align = NewAl
    PropertyChanged "Alignment"
    RefreshIt
End Property

Private Sub RefreshIt()
    SetTextColor hDC, TranslateColor(m_FClr)
    Render
End Sub

Private Sub UserControl_InitProperties()
    Debug.Print "InitProperties"
    m_Caption = Extender.Name
    m_Enabled = True
    m_DrawFocusRect = True
    m_Align = alCenter
    m_HClr = &HC0&
    m_FClr = &H80&
    m_DClr = &H4799E1
    m_PBClr = &H7AD0FA
    m_UnPushed = bsSoftUp
    m_Pushed = bsSoftDn
    m_Hover = bsSoftUp
    m_BackColor = &H7AD0FA
    m_FocusColor = &HE6AA8C
    Set m_Font = Ambient.Font
    Width = 1075
    Height = 375
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
'    Debug.Print "ReadProperties"
    m_Caption = PropBag.ReadProperty("Caption", Extender.Name)
    m_Enabled = PropBag.ReadProperty("Enabled", True)
    m_DrawFocusRect = PropBag.ReadProperty("DrawFocusRect", True)
    m_Align = PropBag.ReadProperty("Alignment", alLeft)
    m_HClr = PropBag.ReadProperty("HoverColor", &HC0&)
    m_FClr = PropBag.ReadProperty("ForeColor", &H80&)
    m_DClr = PropBag.ReadProperty("DownColor", &H4799E1)
    m_PBClr = PropBag.ReadProperty("PictureBackColor", &H7AD0FA)
    m_UnPushed = PropBag.ReadProperty("OnUp", bsSoftUp)
    m_Pushed = PropBag.ReadProperty("OnDown", bsSoftDn)
    m_Hover = PropBag.ReadProperty("OnHover", bsSoftUp)
    m_BackColor = PropBag.ReadProperty("BackColor", &H7AD0FA)
    m_FocusColor = PropBag.ReadProperty("FocusColor", &HE6AA8C)
 
    Set pBtnPic.Picture = PropBag.ReadProperty("Picture", Nothing)
    If pBtnPic.Picture <> Empty Then
        MaskPicture pBtnPic
    End If
    Set m_Font = PropBag.ReadProperty("Font", Ambient.Font)
    Set UserControl.Font = m_Font
 
    UserControl.Enabled = m_Enabled

    RefreshIt
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
'    Debug.Print "WriteProperties"
    Call PropBag.WriteProperty("Caption", m_Caption, Extender.Name)
    Call PropBag.WriteProperty("Enabled", m_Enabled, True)
    Call PropBag.WriteProperty("DrawFocusRect", m_DrawFocusRect, True)
    Call PropBag.WriteProperty("Alignment", m_Align, alLeft)
    Call PropBag.WriteProperty("HoverColor", m_HClr, &HC0&)
    Call PropBag.WriteProperty("ForeColor", m_FClr, &H80&)
    Call PropBag.WriteProperty("DownColor", m_DClr, &H4799E1)
    Call PropBag.WriteProperty("PictureBackColor", m_PBClr, &H7AD0FA)
    Call PropBag.WriteProperty("Font", m_Font, Ambient.Font)
    Call PropBag.WriteProperty("OnUp", m_UnPushed, bsSoftUp)
    Call PropBag.WriteProperty("OnDown", m_Pushed, bsSoftDn)
    Call PropBag.WriteProperty("OnHover", m_Hover, bsSoftUp)
    Call PropBag.WriteProperty("Picture", pBtnPic.Picture, Nothing)
    Call PropBag.WriteProperty("BackColor", m_BackColor, &H7AD0FA)
    Call PropBag.WriteProperty("FocusColor", m_FocusColor, &HE6AA8C)
End Sub

Public Property Get HoverColor() As OLE_COLOR
    HoverColor = m_HClr
End Property

Public Property Let HoverColor(ByVal NewClr As OLE_COLOR)
    m_HClr = NewClr
    PropertyChanged "HoverColor"
End Property

Public Property Get ForeColor() As OLE_COLOR
    ForeColor = m_FClr
End Property

Public Property Let ForeColor(ByVal NewClr As OLE_COLOR)
    m_FClr = NewClr
    PropertyChanged "ForeColor"
    RefreshIt
End Property

Public Property Get DownColor() As OLE_COLOR
    DownColor = m_DClr
End Property

Public Property Let DownColor(ByVal NewClr As OLE_COLOR)
    m_DClr = NewClr
    PropertyChanged "DownColor"
End Property

Public Property Get Font() As StdFont
    Set Font = m_Font
End Property

Public Property Set Font(ByVal NewFont As StdFont)
    Set m_Font = NewFont
    Set UserControl.Font = m_Font
    PropertyChanged "Font"
    RefreshIt
End Property

Public Property Get OnDown() As eEdgeDn
    OnDown = m_Pushed
End Property

Public Property Let OnDown(ByVal NewVal As eEdgeDn)
    m_Pushed = NewVal
    PropertyChanged "OnDown"
End Property

Public Property Get OnUp() As eEdgeUp
    OnUp = m_UnPushed
End Property

Public Property Let OnUp(ByVal NewVal As eEdgeUp)
    m_UnPushed = NewVal
    PropertyChanged "OnUp"
    RefreshIt
End Property

Public Property Get OnHover() As eEdgeUp
    OnHover = m_Hover
End Property

Public Property Let OnHover(ByVal NewVal As eEdgeUp)
    m_Hover = NewVal
    PropertyChanged "OnHover"
End Property

Public Property Get Picture() As Picture
    Set Picture = pBtnPic.Picture
End Property

Public Property Set Picture(ByVal NewPic As Picture)
    Set pBtnPic.Picture = NewPic
    PropertyChanged "Picture"
    If pBtnPic.Picture <> Empty Then
        MaskPicture pBtnPic
    End If
    RefreshIt
End Property

Public Property Get PictureBackColor() As OLE_COLOR
    PictureBackColor = m_PBClr
End Property

Public Property Let PictureBackColor(ByVal NewClr As OLE_COLOR)
    m_PBClr = NewClr
    PropertyChanged "PictureBackColor"
    If pBtnPic.Picture <> Empty Then
        MaskPicture pBtnPic
    End If
    RefreshIt
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = m_BackColor
End Property

Public Property Let BackColor(ByVal NewBackColor As OLE_COLOR)
    m_BackColor = NewBackColor
    PropertyChanged "BackColor"
    RefreshIt
End Property

Public Property Get FocusColor() As OLE_COLOR
    FocusColor = m_FocusColor
End Property

Public Property Let FocusColor(ByVal NewFocusColor As OLE_COLOR)
    m_FocusColor = NewFocusColor
    PropertyChanged "FocusColor"
    RefreshIt
End Property

Private Sub MaskPicture(pb As PictureBox)
    Dim X As Single, Y As Single
    Dim lMskClr As Long
    pb.Cls
    lMskClr = GetPixel(pb.hDC, 0, 0)
    For X = 0 To pb.ScaleWidth
        For Y = 0 To pb.ScaleHeight
            If GetPixel(pb.hDC, X, Y) = lMskClr Then
                SetPixel pb.hDC, X, Y, TranslateColor(m_PBClr)
            End If
        Next
    Next
End Sub
